#!/bin/ash
rCRF="/root/Choices/ROX-Filer";DIM="/usr/local/Desktop_Icons-Menu"
ScripT="# $DIM/icones-bureau.sh # v. 0.1"
Auteur="# © Christian L'Écuyer,Gatineau (Qc), Canada, 2018-01-11 à 13. GPL3
# (Alias musher0 [forum Puppy].)";Dieses="###############"
ExecS="aemenu-pango (vovchik), xwininfo, replaceit, awk"

# Panneaux d'aide en console | Help panels in console
case "$@" in a|A)echo -e "\e[34m$Dieses\n$ScripT\n#
# Objectif : créer un menu ae à partir des icônes sur un punaiseur PuppyPin,
# .......... et l'utiliser dans un 2e punaiseur n'ayant que l'icône du\n# .......... présent script.\n#
# Usage (FR) : un clic droit sur l'icône de ce script dans un punaiseur\n# .......... « peuplé » le vide;
#\n# .......... un clic droit sur l'icône de ce script dans un punaiseur vide\n# .......... affiche le menu;
#\n# .......... cliquer sur l'entrée « Recycler » du présent menu le rafraichit
# .......... (si vous avez changé le punaiseur peuplé depuis la dernière\n# .......... utilisation du présent script);
#\n# .......... cliquer sur l'entrée « Peupler » du présent menu vous\n# .......... ramène au punaiseur d'origine.\n#
# Aide : Taper < ./icones-bureau.sh a > dnas le rép. pour lire le présent
# ....... panneau d'aide, < ./icones-bureau.sh L > pour lire la license.\n#
# Requiert : $ExecS, un fichier\n# .......... texte à /root/panel_app contenant le nom valide d'une barre
# .......... de tâches et d'icônes, par ex. bmpanel2, et le fichier de réf.
# .......... /root/my-doc*s/Docs_Linux/Unicode-accents-tableau.txt2,
# .......... le script /root/.aewm/ae/fonte+couleurs.sh. Tous les fichiers
# .......... requis sont fournis par le Puppy ou par l'archive pet.\n#
$Auteur\n$Dieses$Dieses\e[0m" | more ;;

	h|H)echo -e "\e[34m$Dieses\n$ScripT\n#
# Goal: Create an ae menu from the icons on a ROX pinboard and use
# ........... it on a 2nd pinboard that has only the icon for this script.\n#
# Usage (EN) : a left click on the icon of this script in a \"populated\"\n# .......... pinboard empties it;
#\n# .......... a left click on the icon of this script in an empty pinboard\n# .......... shows this menu;
#\n# .......... clicking on this menu's \"Recycle\" entry refreshes this menu (if
# .......... you have changed the PuppyPin since you last used this script);
#\n# .......... clicking on the menu's \"Populate\" entry brings back the\n# .......... original PuppyPin.\n#
# Help: Type < ./icones-bureau.sh h > in the dir. to read this help panel,
# ......... < ./icones-bureau.sh L > to read the licence.\n#
# Requires: $ExecS, a text file at\n# .......... /root/panel_app containing the valid name of a task-and-tray
# ......... bar, e.g. bmpanel2, reference file
# ......... /root/my-doc*s/Docs_Linux/Unicode-accents-tableau.txt2,
# ......... and script /root/.aewm/ae/fonte+couleurs.sh. All required
# ......... files are provided by the Puppy or the pet archive.\n#
$Auteur\n$Dieses$Dieses\e[0m" | more ;;

	l|L) echo -e "\e[34m$Dieses\n$ScripT\n$Auteur # https://opensource.org/licenses/GPL-3.0\n$Dieses
#    This program is free software: you can redistribute it and/or modify it under the
#    terms of the GNU General Public License as published by the Free Software Foundation,
#    either version 3 of the License, or  (at your option) any later version.
#    	This program is distributed in the hope that it will be useful, but WITHOUT ANY
#    WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
#    A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#    	You should have received a copy of the GNU General Public License along with
#   this program. If not, see <http://www.gnu.org/licenses/>.\n$Dieses
#   Ce programme est libre : vous pouvez le redistribuer ou modifier selon les termes
#   de la Licence Publique Générale GNU publiée par la Free Software Foundation (v. 3
#   ou toute version ultérieure choisie par vous).
#       Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE
#   GARANTIE, ni explicite ni implicite, y compris des garanties de commercialisation
#   ou d'adaptation à un but spécifique. Pour plus de détails, veuillez vous reporter
#   au texte officiel de cette licence à https://opensource.org/licenses/GPL-3.0, à
#   http://www.linux-france.org/article/these/gpl.html pour une traduction et, pour une
#   explication en français, à https://fr.wikipedia.org/wiki/Licence_publique_générale_GNU.
$Dieses$Dieses\e[0m" | more ;;

	n|N) echo -e "\e[34m$Dieses\n$ScripT\n### NOTES ###
# Speed\n# - creation: +/- 0.68 sec.; repeat: +/- 0.17 sec., depending on your box.
#\n# -=> Remove the marker file $rCRF/vide manually if
# ... script is stuck on main PuppyPin, and re-click. <=- (Will happen
# ... after you've changed WMs or rebooted from the empty pinboard.)
# ... Or click on the \"Unstick\" entry in the \"This menu\" sub-menu.\n#
# ... Hot key Win-P displays this menu where the cursor is.
$Dieses
# Vitesse
# - création : +/- 0,68 sec.; répétition : +/- 0,17 sec., selon votre ordi.
#\n# -=> Enlever le fichier marqueur $DIM/vide à la main
# ... si le script est coincé sur le punaiseur principal, et recliquer. <=-
# ... (Cela arrivera si vous avez changé de gest. de fen. ou redémarré
# ... depuis le punaiseur vide.) Ou bien cliquer sur l'entrée « Décoincer »
# ... dans le sous-menu « Ce menu ».\n#
# ... La combinaison de touches Win-P affiche ce menu au curseur.
$Dieses$Dieses\e[0m" | more ;;

	*)cd $rCRF # Action
case "${LANG:0:2}" in fr)Peupl=peupler;IconBur="Icônes_Bureau"
		Rafr=Recycler;Decoince=Décoincer;Ce=Ce;ReP="Rép." ;;
	en|*)Peupl=populate;IconBur="Desktop_Icons";
		Rafr=Refresh;Decoince=Unstick;Ce=This;ReP="Dirs" ;;
esac
PaneL="`cat /root/panel_app`"

# Not the same backdrop or not empty? We build it.
M="`awk -F"<" '$2 ~ /backdrop/ { print $2 }' $rCRF/PuppyPin | awk -F">" '{ print $2 }'`"
m="`awk '$1 ~ /backdrop/ { print $0 }' $rCRF/PuppyPin | wc -c`"
N="`awk -F"<" '$2 ~ /backdrop/ { print $2 }' $rCRF/PuppyPin-vide | awk -F">" '{ print $2 }'`"
n="`awk '$1 ~ /backdrop/ { print $0 }' $rCRF/PuppyPin-vide | wc -c`"
if [ "$m" -ne "$n" -o "$M" != "$N" -o ! -f $rCRF/PuppyPin-vide ];then
	Width="`xwininfo -root | awk '$1 ~ /idth/ { print $2 }'`";	Width="`expr $Width - 32`"
	Height="`xwininfo -root | awk '$1 ~ /eight/ { print $2 }'`";Height="$(( ($Height / 2) + 42 ))"
	head -n 3 PuppyPin > $rCRF/PuppyPin-vide
	echo "  <icon x=\"$Width\" y=\"$Height\" label=\"Re$Peupl\" shortcut=\"Super+Hyper+p\">/usr/bin/icones-bureau.sh</icon>
</pinboard>" >> $rCRF/PuppyPin-vide
fi

if [ ! -f  $DIM/vide ];then # Si le fichier « vide » n'existe pas, le créer.
	echo marqueur > $DIM/vide
	[ "`pgrep $PaneL`" ] && killall -q $PaneL  # If task-and-tray bar not defined, we pass.
	rox -p $rCRF/PuppyPin-vide # Punaiseur plein a besoin seulement d'une icône.
else # Le punaiseur vide a besoin de ce menu ET de l'icône de ce script.
	kill -s 15 `pgrep aemenu` &>/dev/null;sleep 0.1s # Précaution.

	FichUtil="$DIM/icones-bureau"
	if [ ! -f $FichUtil ];then # NExist=1;NLignes=0
		LC_ALL=C # Boulevard !
		AEM="/root/.aewm/ae";MBINS="/opt/local/bin" # Vars, 2e série.

		$AEM/fonte+couleurs.sh # Mise en forme # Pour l'uniformité |
		> /tmp/VarsPango # Layout # For consistency
		for i in CaracT SizE ColoR ColoR2 BgColoR;do
			echo "$i=\"`cat /usr/local/share/$i`\"" >> /tmp/VarsPango
		done
		. /tmp/VarsPango
		[ "$CaracT" = "" ] && CaracT=DejaVuSans
		[ "$SizE" = "" ] && SizE=11;SizE="$(($SizE + 3))"
		ColoR2="${ColoR2:0:7}";[ "$ColoR2" = "$ColoR" ] && ColoR2=grey31
		BgColoR="${BgColoR:0:7}";[ BgColoR="#000\nt" ] && BgColoR="#000000"
		[ BgColoR="#FFF\nt" -o BgColoR="#fff\nt" ] && BgColoR="#603B28"
		SprtR2="<span color='$ColoR'>━━━━━━━━━━━</span>"

# Re-action
		LignE () { echo -e "cmd \"\t$SprtR2\" \"$FichUtil.sh\"" >> $DIM/icones-bureau; }
		LignE2 () { echo -e "\tcmd \"$SprtR2\" \"$FichUtil.sh\"" >> $DIM/icones-bureau; }

		awk -F">" '$1 ~ /icon/ { print $(NF-1) }' PuppyPin | awk -F"<" '{ print $1 }' | sort > $DIM/liste
		> $DIM/icones-bureau.tmp # Trying to satisfy many conditions.
		while read line;do B="`echo $line | awk -F"/" '{ print $NF }'`"
			case "$line" in *.desktop)C="\"rox $line\"";B="${B%.*}" ;;
				*default*)B="${B#*t}"
					case "$B" in filemanager)C="\"rox /root\"" ;;
						*)C="$line" ;;
					esac ;;
				*drive_drives)C=/root/.pup_event/drive_drives/AppRun ;;
				*.sh)C="$line";B="${B%.*}" ;;
				*Trash|*Xlock|*mnt*|*)C="\"rox \\\"$line\\\"\"" ;;
			esac
			echo "cmd \"$B\" $C" >> $DIM/icones-bureau.tmp
		done < $DIM/liste
		sort $DIM/icones-bureau.tmp > $DIM/icones-bureau.t1

		EnD () { echo end >> $FichUtil; } # Construction
		echo -e "## aemenu ## Ne pas éditer directement. | Do not edit directly. ##
# Created by | Créé par le / script $FichUtil.sh #
# © Christian L'Écuyer, Gatineau (Qc), Canada, 2018-01-11 & 12. GPL3. #\n
menu \" <span rise='-12000' font='$Caract Bold $SizE' underline='double'><span color='$ColoR' bgcolor='$BgColoR' ><i>  $IconBur  </i></span></span>\"" > $FichUtil;LignE2
		echo -e "cmd \"   $Rafr\" \"rm -f $DIM/icones-bureau\"
	cmd \"  $Decoince\" \"rm -f $DIM/vide\" # Voir | See / Note.
	cmd \"  Re$Peupl\" \"rm -f $DIM/vide;[ "`pgrep $PaneL`" ] && killall -q $PaneL;sleep 0.5s;rox -p $rCRF/PuppyPin\"" >> $FichUtil;LignE2
		EnD
		echo -e "cmd \"<span font='Serif 2'><i> </i></span>\" $FichUtil.sh" >> $FichUtil
		echo -e "menu \"\t    App. & Util.\"">> $FichUtil;LignE2
		cat  $DIM/icones-bureau.t1 | grep -E -v "mnt|drive_drives|Trash|fileman" >> $FichUtil;LignE2
		EnD
		echo -e "menu \"\t   Part. & $ReP\"" >> $FichUtil;LignE2
		cat  $DIM/icones-bureau.t1 | grep -E "mnt|drive_drives|Trash|fileman" >> $FichUtil;LignE2
		EnD;LignE

		LC_ALL="" # Fin du | End of / boulevard.

		RPLCT="replaceit --input=$FichUtil" # Touch-ups for | Retouches pour / UTF-8
		while read line;do # Pour les accents. | For accented characters.
			i=1 # Combien de fois dans le menu ?
			times="`grep -E "${line% *}" -c $FichUtil`";times=$(($times + 1))
			while [ "$i" -le "$times" ];do
				$RPLCT  "${line% *}" "${line#* }";i=$(($i + 1))
			done
		done < $DIM/Unicode-accents-tableau.txt2
		rm -f $DIM/icones-bureau.t*;rm -f $DIM/liste # Nettoyage | Clean-up.
	fi
	GTK2_RC_FILES=/root/.aewm/ae/aepanel-Gulfstream.gtkrc aemenu-pango -rc $FichUtil 2>/dev/null
fi ;;
esac
