#!/bin/sh
# $AEM/fonte+couleurs.sh # Requiert : / Requires: aemenu-pango & bcm (par vovchik),
# pour la mise en forme des aemenus-pango.
# (c) Christian L'Écuyer, Gatineau (Qc), Canada, 20 mars 2017. GPL3
# # (Alias musher0 [forum Puppy].) Rév. 1er mai 2017.
#### set -xe
awk -F"\"" '$1 ~ /font_/ { print $2 }' /root/.gtkrc-2.0  | awk '{ print $1$2$3 }' > /usr/local/share/CaracT
awk '$1 ~ /font_name/ { print $NF }' /root/.gtkrc-2.0 | awk -F"\"" '{ print $1 }' > /usr/local/share/SizE
awk -F"\"" '$1 ~ /include/ && $0 ~ /themes/ { print $2 }' /root/.gtkrc-2.0 > /usr/local/share/TheM
TheM="`cat /usr/local/share/TheM`" # echo $TheM

if [ "`awk -F":" '$1 ~ /scheme/ && $0 ~ /selected_fg_color/ { print $NF }' $TheM`" = "" ];then
	awk -F"\"" '$1 ~ /fg\[NORMAL\]/ { print $2 }' $TheM | head -1 >  /usr/local/share/ColoR
# text\[NORMAL\]
	awk -F"\"" '$1 ~ /base\[NORMAL\]/ { print $2 }' $TheM | head -1 >  /usr/local/share/ColoR2
	awk -F"\"" '$1 ~ /base\[PRELIGHT\]/ { print $2 }' $TheM | head -1 >  /usr/local/share/BgColoR
else
	awk -F":" '$1 ~ /scheme/ && $0 ~ /selected_fg_color/ { print $NF }' $TheM | awk -F"\"" '{ print $1 }' | head -1 >  /usr/local/share/ColoR
	awk -F":" '$1 ~ /scheme/ && $0 ~ /selected_fg_color/ { print $(NF-1) }' $TheM | awk -F"\"" '{ print $1 }' | head -1 >  /usr/local/share/ColoR2
	awk -F":" '$1 ~ /scheme/ && $0 ~ /selected_fg_color/ { print $6 }' $TheM | awk -F"\"" '{ print $1 }' | head -1 >  /usr/local/share/BgColoR
fi # Couvre +/- 77.25 % des thèmes GTK

# Avec les corrections suivantes, ce sera pas forcément joli, mais
# on « absorbe », on peut se servir d'à peu près tous les thèmes.
ColoR="`cat  /usr/local/share/ColoR`"
[ ColoR="#000" -o ColoR="#000\nt" ] && echo "#000000" > /usr/local/share/ColoR
# 000\nt
[ ColoR="#FFF" -o  ColoR="#fff" -o ColoR="#FFF\nt"  -o ColoR="#fff\nt" ] && echo "#FFFFFF" > /usr/local/share/ColoR
[ "${#ColoR}" -lt "7" -o "${ColoR}" = "" ] && echo "#CDEFDE" > /usr/local/share/ColoR

ColoR2="`cat  /usr/local/share/ColoR2`"
[ ColoR2="#000" -o ColoR2="#000\nt" ] && echo "#000000" > /usr/local/share/ColoR2
[ ColoR2="#FFF" -o ColoR2="#fff" -o ColoR2="#FFF\nt" -o ColoR2="#fff\nt" ] && echo "#FFFFFF" > /usr/local/share/ColoR2
[ "${#ColoR2}" -lt "7" -o "${ColoR2}" = "" ] && echo "#C3AF99" > /usr/local/share/ColoR2

BgColoR="`cat  /usr/local/share/BgColoR`"
[ BgColoR="#000" -o BgColoR="#000nt" ] && echo "#000000" > /usr/local/share/BgColoR
[ BgColoR="#FFF" -o  BgColoR="#fff" -o BgColoR="#FFF\nt" -o BgColoR="#fff\nt" ] && echo "#13579B" > /usr/local/share/BgColoR
[ "${#BgColoR}" -lt "7" -o "${BgColoR}" = "" ] && echo "#A9A9A9" > /usr/local/share/BgColoR # "#A7C4B0"
[ "`awk '/494949|000000|FFFFFF|ffffff|75507b|4D4440/' /usr/local/share/BgColoR`" ] && echo "#A9A9A9" > /usr/local/share/BgColoR
[ "`awk '/6590b8|A7CC5C/' /usr/local/share/BgColoR`" ] && echo "#995533" > /usr/local/share/BgColoR
# #D5DFBC # #E2E9D2

# Important --
# Les lignes suivantes doivent figurer dans le script de création des menus :
# CaracT="`cat /usr/local/share/CaracT`" # echo $CaracT
# ColoR="`cat  /usr/local/share/ColoR`" # echo $ColoR
# ColoR2="`cat  /usr/local/share/ColoR2`";ColoR2="${ColoR2:0:7}"
# BgColoR="`cat  /usr/local/share/BgColoR`";BgColoR="${BgColoR:0:7}"
#
# set +xe
